package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.Answer;
import com.ekexiu.console.system.po.Question;
import com.ekexiu.console.system.pojo.AnswerInfo;
import com.ekexiu.console.system.pojo.QuestionInfo;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.SetSentence;
import org.jfw.apt.orm.annotation.dao.method.Where;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.PageQuery;
import org.jfw.apt.orm.annotation.dao.method.operator.QueryOne;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Like;
import org.jfw.apt.orm.annotation.dao.param.Set;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2018/1/26.
 */
@DAO
public interface QuestionDao {
    @PageQuery
    @OrderBy(" ORDER BY create_time DESC ")
    @Where(" a.STATE='1'")
    PageQueryResult<AnswerInfo> answerByTime(Connection con, @Nullable @Like String questionTitle, @Nullable @Like String respondent, @Nullable @Like String cnt, int pageSize, int pageNo)throws SQLException;

    @PageQuery
    @OrderBy(" ORDER BY agree DESC")
    @Where("a.STATE='1'")
    PageQueryResult<AnswerInfo> answerByAgree(Connection con, @Nullable @Like String questionTitle, @Nullable @Like String respondent, @Nullable @Like String cnt, int pageSize, int pageNo)throws SQLException;

    @PageQuery
    @OrderBy(" ORDER BY ballot DESC")
    @Where("a.STATE='1'")
    PageQueryResult<AnswerInfo> answerByBallot(Connection con, @Nullable @Like String questionTitle, @Nullable @Like String respondent, @Nullable @Like String cnt, int pageSize, int pageNo)throws SQLException;

    @QueryOne
    @Nullable
    AnswerInfo queryAnswer(Connection con, String id) throws SQLException;

    @UpdateWith
    @From(Answer.class)
    @Where("STATE='1'")
    //@SetSentence("MODIFY_TIME=TO_CHAR(NOW(),'YYYYMMDDHH24MISS')")
    int updateAnswer(Connection con, String id, @Set String cnt) throws SQLException;

    @DeleteWith
    @From(Answer.class)
    int deleteAnswer(Connection con, String id,String qid)throws SQLException;


    @UpdateWith
    @From(Question.class)
    @SetSentence("REPLY_COUNT=REPLY_COUNT-1")
    @Where("REPLY_COUNT >0")
    int decQuestionReply(Connection con,String id)throws SQLException;

    @PageQuery
    @OrderBy("order by create_time DESC")
    @Where("STATE='1'")
    PageQueryResult<QuestionInfo> questionByTime(Connection con, @Nullable @Like String title, @Nullable @Like String requester, int pageSize, int pageNo)throws SQLException;

    @PageQuery
    @OrderBy("order by page_views DESC")
    @Where("STATE='1'")
    PageQueryResult<QuestionInfo> questionByPV(Connection con, @Nullable @Like String title, @Nullable @Like String requester, int pageSize, int pageNo)throws SQLException;

    @PageQuery
    @OrderBy("order by reply_count DESC")
    @Where("STATE='1'")
    PageQueryResult<QuestionInfo> questionByReply(Connection con, @Nullable @Like String title, @Nullable @Like String requester, int pageSize, int pageNo)throws SQLException;

    @QueryOne
    @Nullable
    QuestionInfo queryQuestion(Connection con, String id) throws SQLException;

    @UpdateWith
    @From(Question.class)
    @Where("STATE='1'")
        //@SetSentence("MODIFY_TIME=TO_CHAR(NOW(),'YYYYMMDDHH24MISS')")
    int updateQuestion(Connection con, String id, @Set String cnt,@Set String img) throws SQLException;

    @UpdateWith
    @From(Question.class)
    int updataQetKey(Connection con, String id, @Set String keys)throws SQLException;

    @UpdateWith
    @From(Question.class)
    @SetSentence("STATE='0'")
    @Where("STATE ='1'")
    int logicDeleteQuestion(Connection con, String id) throws SQLException;
}
