package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.Ware;
import com.ekexiu.console.system.pojo.WareInfo;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.Batch;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.Exclude;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.SetSentence;
import org.jfw.apt.orm.annotation.dao.method.Where;
import org.jfw.apt.orm.annotation.dao.method.operator.PageQuery;
import org.jfw.apt.orm.annotation.dao.method.operator.QueryOne;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.Update;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Alias;
import org.jfw.apt.orm.annotation.dao.param.GtEq;
import org.jfw.apt.orm.annotation.dao.param.Like;
import org.jfw.apt.orm.annotation.dao.param.LtEq;
import org.jfw.apt.orm.annotation.dao.param.Set;
import org.jfw.apt.orm.annotation.dao.param.SqlColumn;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2018/3/20.
 */
@DAO
public interface WareDao {

    @SelectOne
    @Nullable
    Ware queryById(Connection con, String id) throws SQLException;

    @Update
    @Exclude("modifyTime")
    int update(Connection con, Ware ware) throws SQLException;

    @Nullable
    @QueryOne
    WareInfo query(Connection con, String id) throws SQLException;

    @PageQuery
    @OrderBy(" ORDER BY modify_time DESC NULLS LAST")
    @Where("state='1'")
    @Exclude("descp")
    PageQueryResult<WareInfo> queryByTime(Connection con, @Nullable @Like String name,@Nullable @SqlColumn(value = {"(p.name is null or p.name like ?)", "(o.name is null or o.name like ?)"}, handlerClass = StringHandler.class) String author, @Nullable @GtEq @Alias("modifyTime") String bt, @Nullable @Alias("modifyTime") @LtEq String et, int pageSize, int pageNo) throws SQLException;

    @PageQuery
    @OrderBy(" ORDER BY page_views DESC NULLS LAST")
    @Where("state='1'")
    @Exclude("descp")
    PageQueryResult<WareInfo> queryByPV(Connection con, @Nullable @Like String name,@Nullable @SqlColumn(value = {"(p.name is null or p.name like ?)", "(o.name is null or o.name like ?)"}, handlerClass = StringHandler.class) String author, @Nullable @GtEq @Alias("modifyTime") String bt, @Nullable @Alias("modifyTime") @LtEq String et, int pageSize, int pageNo) throws SQLException;

    @Batch
    @UpdateWith
    @From(Ware.class)
    @Where("STATE<>'0'")
    @SetSentence("STATE = '0'")
    int[] logicDelete(Connection con, @Batch String[] id) throws SQLException;

    @UpdateWith
    @From(Ware.class)
    int updateSortFirst(Connection con, String id, @Set long sortFirst) throws SQLException;

    @UpdateWith
    @From(Ware.class)
    int updateKw(Connection con, String id, @Set String keywords) throws SQLException;

}
