package com.ekexiu.console.system.service;

import com.ekexiu.console.system.dao.WareDao;
import com.ekexiu.console.system.pojo.WareInfo;
import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.PathVar;
import org.jfw.util.PageQueryResult;

import java.io.File;
import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2018/3/21.
 */
@Path("/ware")
public class WareService {
    private File imgPath;

    @Autowrie
    private WareDao wareDao;
    @Autowrie
    private KeyWordService keyWordService;

    public File getImgPath() {
        return imgPath;
    }

    public void setImgPath(File imgPath) {
        this.imgPath = imgPath;
    }

    public WareDao getWareDao() {
        return wareDao;
    }

    public void setWareDao(WareDao wareDao) {
        this.wareDao = wareDao;
    }

    public KeyWordService getKeyWordService() {
        return keyWordService;
    }

    public void setKeyWordService(KeyWordService keyWordService) {
        this.keyWordService = keyWordService;
    }

    //public boolean update(Connection con, Ware ware, String[] professor, String[] resource) throws SQLException, IOException {
    //    String id = ware.getId();
    //    if (wareDao.update(con, ware) > 0) {
    //        this.saveSmallImg(ware.getImages());
    //        if (ware.getState().equals("1")) {
    //            keyWordService.refreshWare(con, id, ware.getKeywords());
    //        } else {
    //            keyWordService.deleteWare(con, id);
    //        }
    //        wareDao.deleteWareRes(con, id);
    //        if (resource != null && resource.length > 0) {
    //            for (String rid : resource) {
    //                WareRes wr = new WareRes();
    //                wr.setId(id);
    //                wr.setResource(rid);
    //                wareDao.insert(con, wr);
    //            }
    //        }
    //        wareDao.deleteWarePro(con, id);
    //        if (professor != null && professor.length > 0) {
    //            for (String pid : professor) {
    //                WarePro wp = new WarePro();
    //                wp.setId(id);
    //                wp.setProfessor(pid);
    //                wareDao.insert(con, wp);
    //            }
    //        }
    //        return true;
    //    }
    //    return false;
    //}
    //
    //private void saveSmallImg(String imgs) throws IOException {
    //    if (imgs != null) {
    //        List<String> list = ListUtil.splitTrimExcludeEmpty(imgs, ',');
    //        if (list.size() > 0) {
    //            String oname = list.get(0);
    //            if (oname != null) {
    //                if (oname.startsWith("/")) {
    //                    oname = oname.substring(1);
    //                    int idx = oname.indexOf('.');
    //                    if (idx > 0) {
    //                        String dname = oname.substring(0, idx) + "_s.jpg";
    //                        File dest = new File(this.imgPath, dname);
    //                        if (dest.exists())
    //                            return;
    //                        File src = new File(this.imgPath, oname);
    //                        if (src.exists()) {
    //                            byte[] obs = IoUtil.readStream(new FileInputStream(src), true);
    //                            obs = JpgUtil.read(obs);
    //                            FileOutputStream out = new FileOutputStream(dest);
    //                            try {
    //                                JpgUtil.scalingZoom(new ByteArrayInputStream(obs), out, this.imgMaxWidth);
    //                                out.flush();
    //                            } finally {
    //                                IoUtil.close(out);
    //                            }
    //                        }
    //                    }
    //                }
    //            }
    //        }
    //    }
    //}

    @Path("/pq")
    @Get
    public PageQueryResult<WareInfo> pageQueryResult (@JdbcConn Connection con, @Nullable String name, @Nullable String author, int orderBy, @Nullable String bt, @Nullable String et, @DefaultValue("1")int pageNo,@DefaultValue("10")int pageSize)throws SQLException {
        if (orderBy == 1) {
            return this.wareDao.queryByTime(con,name==null?null:"%"+name+"%",author==null?null:"%"+author+"%",bt == null?null:bt+"000000", et == null ? null : et + "235959", pageSize, pageNo);
        } else if (orderBy == 2) {
            return this.wareDao.queryByPV(con, name == null ? null : "%" + name + "%", author == null ? null : "%" + author + "%", bt == null ? null : bt + "000000", et == null ? null : et + "235959", pageSize, pageNo);
        }else {
            return null;
        }
    }

    @Post
    @Path(" /deleteWare")
    public void deleteWare(@JdbcConn(true)Connection con,String[] ids)throws SQLException {
        this.wareDao.logicDelete(con, ids);
    }

    @Post
    @Path("/sortFirst")
    public void updateSortFirst(@JdbcConn(true)Connection con,String id,long sortFirst)throws SQLException {
        this.wareDao.updateSortFirst(con, id, sortFirst);
    }

    @Get
    @Path("/id/{id}")
    public WareInfo query(@JdbcConn Connection con,@PathVar String id)throws SQLException {
        return this.wareDao.query(con, id);
    }

    @Post
    @Path("/kw")
    public void updateKw(@JdbcConn(true)Connection con,String id,@Nullable String kw)throws SQLException {
        this.wareDao.updateKw(con, id, kw);
        this.keyWordService.refreshWare(con, id, kw);
    }



}